/*
/* meta.h copyright (c) 1996 Clemson University, all rights reserved.
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as published
	by the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	Contact:  Rob Ross  	rbross@parl.eng.clemson.edu
				 Matt Cettei mcettei@parl.eng.clemson.edu

/*/

/*
 * $Log: meta.h,v $
 * Revision 1.8  1998/07/02 18:30:17  rbross
 * modified to compile w/glibc-2.0.7-13
 *
 * Revision 1.7  1998/03/13 18:52:12  rbross
 * removed header string
 *
 * Revision 1.6  1998/02/17 22:01:45  rbross
 * added linux/types.h to includes to get umode_t typedef
 *
 * Revision 1.5  1998/02/16 23:34:42  rbross
 * repatched to work w/libc5
 *
 * Revision 1.4  1998/02/16 04:11:40  rbross
 * Newt's glibc patches added
 *
 * Revision 1.3  1997/10/28 19:29:32  pvfs
 * added license
 *
 * Revision 1.2  1997/06/10 18:17:11  walt
 * updated to handle directories
 *
 * Revision 1.1  1997/05/21 16:20:12  rmcettei
 * Initial revision
 *
/*/


#ifndef META_H
#define META_H

/* includes for struct stat */
#include <sys/stat.h>
#include <unistd.h>

/* includes for sockaddr_in */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* includes for umode_t */
#include <asm/types.h>

#ifdef NEED_UMODE_T_DEF
typedef unsigned short umode_t;
#endif

typedef struct dmeta dmeta, *dmeta_p;

struct dmeta {
	ino_t  fs_ino; /* file system root directory inode # */
	uid_t  dr_uid; /* directory owner uid # */
	gid_t  dr_gid; /* directory owner gid # */
	umode_t  dr_mode; /* directory mode # */
	int port;
	char *host;
	char *rd_path;
	char *sd_path;
	char *fname;
};

typedef struct pvfs_stat pvfs_stat, *pvfs_stat_p;
	
struct pvfs_stat {
	int base;
	int pcount;
	int ssize;
	int soff;
	int bsize;
};

typedef struct fmeta fmeta, *fmeta_p;

struct fmeta {
	ino_t  fs_ino; /* file system root directory inode # */
	struct stat u_stat;
	struct pvfs_stat p_stat;
	struct sockaddr mgr;
};

#endif

