/*
/* foo.c copyright (c) 1996 Rob Ross, all rights reserved.
/*/

/*
/* FOO.C - 
/*
/*/

/*
 * $Log: iod.h,v $
 * Revision 1.16  1999/06/17 15:41:01  rbross
 * added NOOP request type
 *
 * Revision 1.15  1999/02/23 20:11:47  rbross
 * took out BACKLOG define
 *
 * Revision 1.14  1998/11/10 21:41:37  rbross
 * uses pvfs_config.h
 *
 * Revision 1.13  1998/07/23 22:05:05  rbross
 * added more request types
 *
 * Revision 1.12  1998/02/17 22:01:30  rbross
 * glibc patch
 *
 * Revision 1.11  1997/11/13 21:21:51  mcettei
 * IOD_BASE_PORT can be defined in make
 *
 * Revision 1.10  1997/11/13 21:15:09  rbross
 * added prototype for do_signal()
 *
 * Revision 1.9  1997/06/25 20:09:07  mcettei
 * add STATNUM
 *
 * Revision 1.8  1997/04/23 17:58:42  mcettei
 * added prototype for do_instr_req
 *
 * Revision 1.7  1997/03/18 00:11:00  rbross
 * added prototype for ack_a_new()
 *
 * Revision 1.6  1997/03/14 05:54:14  rbross
 * moved access type defines from here to alist.h
 *
 * Revision 1.5  1997/02/10 19:33:21  rbross
 * changed do_* names for request service routines to do_*_req
 *
 * Revision 1.4  1996/11/25 21:23:47  rbross
 * nomenclature changes
 *
 * Revision 1.3  1996/11/21 21:17:58  rbross
 * added do_shutdown() prototype
 *
 * Revision 1.2  1996/11/07 19:55:27  mcettei
 * Changed fstat to stat.
 *
 * Revision 1.1  1996/10/31 21:06:17  rbross
 * Initial revision
 *
/*/

#ifndef IOD_H
#define IOD_H

#include <minmax.h>
#include <pvfs_config.h>

static char iod_h[] = "$Header: /projects/pvfs/pvfs-working/iod/RCS/iod.h,v 1.16 1999/06/17 15:41:01 rbross Exp $";

#define STATNUM 5000

/* PROTOTYPES */
char *fname(ino_t f_ino);
int send_error(int status, int eno, int sock, iack_p);
ainfo_p ack_a_new(void);

int do_close_req(int sock, ireq_p r_p, iack_p a_p);
int do_open_req(int sock, ireq_p r_p, iack_p a_p);
int do_rw_req(int sock, ireq_p r_p, iack_p a_p);
int do_stat_req(int sock, ireq_p r_p, iack_p a_p);
int do_unlink_req(int sock, ireq_p r_p, iack_p a_p);
int do_shutdown_req(int sock, ireq_p r_p, iack_p a_p);
int do_gstart_req(int sock, ireq_p r_p, iack_p a_p);
int do_gadd_req(int sock, ireq_p r_p, iack_p a_p);
int do_instr_req(int sock, ireq_p r_p, iack_p a_p);
int do_ftruncate_req(int sock, ireq_p r_p, iack_p a_p);
int do_truncate_req(int sock, ireq_p r_p, iack_p a_p);
int do_fdatasync_req(int sock, ireq_p r_p, iack_p a_p);
int do_noop_req(int sock, ireq_p r_p, iack_p a_p);

void *do_signal(int);

/* DEFINES */
/* mmap defines */
#define PAGENO(x) ((x) & (~(ACCESS_PAGE_SIZE - 1)))
#define PAGEOFF(x) ((x) & (ACCESS_PAGE_SIZE - 1))

#define IOD_MMAP_FLAGS MAP_FILE | MAP_SHARED | MAP_VARIABLE
#define IOD_MMAP_PROT PROT_READ

#ifndef MAP_VARIABLE
#define MAP_VARIABLE 0
#endif


#endif
