/*
/* md_mkdir.c copyright (c) 1996 Clemson University, all rights reserved.
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as published
	by the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	Contact:  Rob Ross  	rbross@parl.eng.clemson.edu
				 Matt Cettei mcettei@parl.eng.clemson.edu

/*/

/*
/* MD_MKDIR.C - 
/*
/*/

/*
 * $Log: md_mkdir.c,v $
 * Revision 1.3  1998/02/16 19:24:57  rbross
 * Newt patches
 *
 * Revision 1.2  1997/10/28 19:16:56  pvfs
 * added license
 *
 * Revision 1.1  1997/06/10 17:52:18  walt
 * Initial revision
 *
 * Revision 1.1  1997/01/16 17:30:31  mcettei
 * Initial revision
 *
 *
/*/

static char md_mkdir_c[] = "$Header: /projects/pvfs/pvfs-working/mgr/meta/RCS/md_mkdir.c,v 1.3 1998/02/16 19:24:57 rbross Exp $";
/*This file contains the chown metadata file call for the PVFS*/
/*Assumes that space for request has been allocated. */

#include <errno.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <linux/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <meta.h>
#include <req.h>

extern int errno;

int md_mkdir(char *dirpath, dmeta_p dir)
{
FILE *fp;
char temp[256];

	/* create dotfile */
	strcpy(temp,dirpath);
	strcat(temp,"/.pvfsdir");
	umask(0033);
	if ((fp = fopen(temp, "w+")) == 0) {
		perror("Error creating dot file");
		return(-1);
	}

	/* write dotfile */
	*(dir->fname-1) = '/';
	fprintf(fp,"%d\n%d\n%d\n%07o\n%d\n%s\n%s\n%s\n\n",dir->fs_ino,dir->dr_uid,dir->dr_gid,dir->dr_mode,dir->port,dir->host,dir->rd_path,dir->sd_path);
	fclose(fp);

	/* return success */
	return(0);

}
