/*
/* put_dmeta.c copyright (c) 1996 Clemson University, all rights reserved.
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as published
	by the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	Contact:  Rob Ross  	rbross@parl.eng.clemson.edu
				 Matt Cettei mcettei@parl.eng.clemson.edu

/*/

/*
 * $Log: put_dmeta.c,v $
 * Revision 1.3  1998/02/16 19:29:21  rbross
 * Newt patches
 *
 * Revision 1.2  1997/10/28 19:21:48  pvfs
 * added license
 *
 * Revision 1.1  1997/06/10 17:52:18  walt
 * Initial revision
 *
 * Revision 1.1  1997/06/04 14:12:08  walt
 * Initial revision
 *
 * Revision 1.1  1997/01/16 16:33:57  mcettei
 * Initial revision
 *
 *
/*/

static char put_dmeta_c[] = "$Header: /projects/pvfs/pvfs-working/mgr/meta/RCS/put_dmeta.c,v 1.3 1998/02/16 19:29:21 rbross Exp $";
/* The put_fname function will take the file name from the request, */
/* write the .pvfsdir file, and return the full file name from the    */
/* mgr's viewpoint - WBL */

#include <errno.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <linux/types.h>
#include <syscall.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <meta.h>

/* GLOBALS */
extern int errno;

int put_dmeta(char * fname, dmeta_p dir) {
int i, length, dlength;
char temp[255];
FILE *fp;

   /* build name of dotfile */
   strcpy(temp, fname);
   length = strlen(temp);
   while (length >= 0 && temp[length] != '/') {
      temp[length] = 0;
      length--;
   }

   /* open dotfile */
   strcat(temp, ".pvfsdir");
   umask(0033);
   if ((fp = fopen(temp, "w+")) == 0) {
      perror("Error opening dot file");
      return(-1);
   }

   /* write dotfile */
   fprintf(fp,"%d\n%d\n%d\n%07o\n%d\n%s\n%s\n%s\n\n",dir->fs_ino,dir->dr_uid,dir->dr_gid,dir->dr_mode,dir->port,dir->host,dir->rd_path,dir->sd_path);
   fclose(fp);

   /* return data */
   return 0;
}
