/*
/* mgr.h copyright (c) 1996 Rob Ross, all rights reserved.
/*/

/*
/* MGR.H - 
/*
/*/

/*
 * $Log: mgr.h,v $
 * Revision 1.17  1999/04/20 21:14:56  rbross
 * *** empty log message ***
 *
 * Revision 1.16  1999/02/23 20:12:09  rbross
 * took out BACKLOG define
 *
 * Revision 1.15  1998/11/10 21:42:14  rbross
 * uses pvfs_config.h
 *
 * Revision 1.14  1998/08/18 18:10:56  spmcmil
 * Added do_utime.
 *
 * Revision 1.13  1998/07/23 21:50:05  rbross
 * added do_truncate()
 *
 * Revision 1.12  1998/03/12 19:07:57  walt
 * don't know -- Rob
 *
 * Revision 1.11  1997/12/03 21:23:50  pvfs
 * changed DEFAULT_BSIZE
 *
 * Revision 1.10  1997/11/13 20:08:14  mcettei
 * macros can be defined by make
 *
 * Revision 1.9  1997/11/11 19:42:26  rbross
 * added prototype for mgr_shutdown
 *
 * Revision 1.8  1997/08/06 18:21:33  pvfs
 * fixed iodpath for grendel
 *
 * Revision 1.7  1997/07/24 16:28:09  walt
 * added rmdir fchmod and fchown
 *
 * Revision 1.6  1997/06/10 17:54:35  walt
 * added mkdir call
 * updated other calls to handle directories
 *
 * Revision 1.5  1997/06/05 17:52:21  rbross
 * *** empty log message ***
 *
 * Revision 1.4  1997/02/26 20:49:25  rbross
 * added prototype for restart()
 *
 * Revision 1.3  1997/02/03 21:13:02  rbross
 * added do_rename prototype
 *
 * Revision 1.2  1997/01/29 19:53:31  mcettei
 * changed defines
 *
 * Revision 1.1  1997/01/20 22:29:56  rbross
 * Initial revision
 *
/*/

#ifndef MGR_H
#define MGR_H

/* INCLUDES */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <desc.h> /* has iod_info structure */
#include <meta.h> /* has pvfs_stat structure */
#include <sockio.h>
#include <sockset.h>
#include <fslist.h>
#include <flist.h>
#include <iodtab.h>
#include <req.h>
#include <minmax.h>
#include <pvfs_config.h>

static char mgr_h[] = "$Header: /projects/pvfs/pvfs-working/mgr/RCS/mgr.h,v 1.17 1999/04/20 21:14:56 rbross Exp $";

/* DEFINES */

/* PROTOTYPES */
int do_access(int, mreq_p, void *, mack_p);
int do_chmod(int, mreq_p, void *, mack_p);
int do_chown(int, mreq_p, void *, mack_p);
int do_close(int, mreq_p, void *, mack_p);
int do_stat(int, mreq_p, void *, mack_p);
int do_mount(int, mreq_p, void *, mack_p);
int do_open(int, mreq_p, void *, mack_p);
int do_umount(int, mreq_p, void *, mack_p);
int do_unlink(int, mreq_p, void *, mack_p);
int do_umount(int, mreq_p, void *, mack_p);
int do_fstat(int, mreq_p, void *, mack_p);
int do_rename(int, mreq_p, void *, mack_p);
int do_shutdown(int, mreq_p, void *, mack_p);
int do_iod_info(int, mreq_p, void *, mack_p);
int do_mkdir(int, mreq_p, void *, mack_p);
int do_rmdir(int, mreq_p, void *, mack_p);
int do_fchown(int, mreq_p, void *, mack_p);
int do_fchmod(int, mreq_p, void *, mack_p);
int do_truncate(int, mreq_p, void *, mack_p);
int do_utime(int, mreq_p, void *, mack_p);
int send_error(int, int, int, mack_p);
fsinfo_p quick_mount(char *, int, int, mack_p);
int stop_iods(void *);
int stop_idle_iods(void *);
void *restart(int sig_nr);
void *mgr_shutdown(int sig_nr);
static void *do_signal(int sig_nr);

/* ERROR AND LOGGING STUFF */
#if 0
#define ERROR(u) perror(u)
#define ERROR1(u, v) fprintf(stderr,"%s", u, v)
#endif

#endif
